﻿using System;
using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = System.Object;

namespace CheesyFX {
	public class ScreenInfo : MonoBehaviour {

		// IMPORTANT - DO NOT make custom enums. The dynamic C# complier crashes Unity when it encounters these for
		// some reason
		
		protected Canvas dynCanvas;
		private GameObject g;
		public Text dynText;
		public float timer = 4f;
		private Color textColor = new Color(1f, 0.5f, 0.99f);
		private Color barColor = new Color();

		public void Run()
		{
			if(g != null)
			{
				g.SetActive(true);
				textColor.a = 1f;
				timer = 4f;
				enabled = true;
			}
		}

		public ScreenInfo Init() {
			g = new GameObject();
			dynCanvas = g.AddComponent<Canvas>();
			dynCanvas.renderMode = RenderMode.WorldSpace;
			// only use AddCanvas if you want to interact with the UI - no needed if display only
			//SuperController.singleton.AddCanvas(dynCanvas);
			CanvasScaler cs = g.AddComponent<CanvasScaler>();
			cs.scaleFactor = 100.0f;
			cs.dynamicPixelsPerUnit = 1f;
			GraphicRaycaster gr = g.AddComponent<GraphicRaycaster>();
			RectTransform rt = g.GetComponent<RectTransform>();
			rt.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, 200f);
			rt.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, 50f);
			g.transform.localScale = new Vector3(0.0006f, 0.0006f, 0.0006f);
			g.transform.localPosition = new Vector3(.15f, .2f, .7f);

			// var bar = new GameObject();
			// bar.transform.SetParent(g.transform, false);
			// var barRT = bar.AddComponent<RectTransform>();
			// barRT.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, 200f);
			// barRT.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, 50f);
			// bar.AddComponent<Image>();
			// image.material.color = barColor;

			// anchor to head for HUD effect
			Transform headCenter = SuperController.singleton.centerCameraTarget.transform;
			rt.SetParent(headCenter, false);

			GameObject g2 = new GameObject();
			g2.name = "Text";
			g2.transform.parent = g.transform;
			g2.transform.localScale = Vector3.one;
			g2.transform.localPosition = Vector3.zero;
			g2.transform.localRotation = Quaternion.identity;
			Text t = g2.AddComponent<Text>();
			RectTransform rt2 = g2.GetComponent<RectTransform>();
			rt2.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, 100f);
			rt2.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, 100f);
			t.alignment = TextAnchor.MiddleCenter;
			t.horizontalOverflow = HorizontalWrapMode.Overflow;
			t.verticalOverflow = VerticalWrapMode.Overflow;
			Font ArialFont = (Font)Resources.GetBuiltinResource(typeof(Font), "Arial.ttf");
			t.font = ArialFont;
			t.fontSize = 24;
			t.text = "Test";
			t.enabled = true;
			t.color = textColor;
			dynText = t;
			g.name = "Canvas";
			
			enabled = false;
			return this;
		}

		void Update()
		{
			timer -= Time.deltaTime;
			if (timer < 0f)
			{
				enabled = false;
			}
			textColor.a = timer * .25f;
			dynText.color = textColor;
		}

		private void OnDisable()
		{
			g.SetActive(false);
		}

		public void OnDestroy() {
			if (dynCanvas != null) {
				//SuperController.singleton.RemoveCanvas(dynCanvas);
				Destroy(g);
			}
		}

	}
}